typedef unsigned char BYTE;
typedef unsigned int WORD;
#define LOWORD( l ) ( ( WORD ) ( ( l ) & 0x0000FFFF ) )
#define HIWORD( l ) ( ( WORD ) ( ( l ) >> 16 ) )



class CDInfo
{
	BYTE num_of_drives;
	BYTE version_upper;
	BYTE version_lower;
	BYTE installed;
	char first_drive;
	void Drives();
	void Version();

	public:
	void GetInfo();
	int Get_Num_of_Drives(){return num_of_drives;}
	char Get_First_Drive(){return first_drive;}
	char Get_Version_Upper(){return version_upper;}
	char Get_Version_Lower(){return version_lower;}
	BYTE Installed(){return installed;}
	int Read_Sector(int,BYTE*,int,long);


};

void CDInfo :: GetInfo()
{
	Drives();
	Version();

}

//Checks if MSCDEX is installed (BYTE installed),how many drives are available(BYTE num_of_drives) 
//and the letter of the first drive (char first_drive);

void CDInfo :: Drives()
{
	union REGS regs;

	regs.x.bx=0;
	regs.h.ah=0x15;
	regs.h.al=0x00;

	int86(0x2F,&regs,&regs);

	num_of_drives=regs.x.bx; //(number of CD-Rom drives. !Problems with network-devices!)
	first_drive=65+regs.x.cx; //(0=A,1=B,... I add 65 to it to get the drive letter in ASCII-format)
	installed=regs.x.bx; //(Checks if MSCDEX is installed 0=not installed , 1=installed)
}

//Checks the MSCDEX Version(for example "2.5=version_upper.version_lower")
void CDInfo :: Version()
{
	union REGS regs;

	regs.h.ah=0x15;
	regs.h.al=0x0C;

	int86(0x2F,&regs,&regs);

	version_upper=regs.h.bh;
	version_lower=regs.h.bl;
}


//Function to read a sector from a CD
//drive_letter=CD-device to read from (0=A,1=B,...)
//lpSector=pointer to a buffer for the sector-data (2048kb per sector)
//sectors=number of sectors to read
//start=sector to start from
int CDInfo :: Read_Sector(int drive_letter,BYTE *lpSector,int sectors,long start )
{ 
  
	union REGS regs;         
 	struct SREGS sregs;      
 	regs.x.ax = 0x1508;
 	sregs.es  = FP_SEG( lpSector );
 	regs.x.bx = FP_OFF( lpSector );
 	regs.x.cx = drive_letter;
 	regs.x.dx = sectors;
 	regs.x.si = HIWORD( start );
 	regs.x.di = LOWORD( start );
 	int86x( 0x2F, &regs, &regs, &sregs );
 	return ( regs.x.cflag == 0 ) ? 1  : 0;
}
